--Sprite LWS_Exporter
--version 0.75 for 3DStudioMax R4
--by Michael Brempel
--mcr -> ...\ui\macroscripts\
--bmp's -> ...\ui\icons\
------------------------------------------------------------------
macroScript LWS_Exporter
category:"MAX Script Tools"
--internalcategory:"MAX Script Tools"
tooltip:"LWS-Exporter"
Icon:#("lws_export",1)
SilentErrors:(Debug == undefined or Debug != True)

(
---------------------------------------------------------Funktionen
fn getsubtree obj =
(
	append harray obj
	for ch in obj.children do 
	(		
		getsubtree ch
	)	
)
-------------------------------------------------------------------
 	r_floater=newrolloutfloater "Savekeys" 190 112
	
	rollout r_info "Info"
	(
		group "Important"
		(
			label l2 "-Select the root of the" align:#left
			label l3 " hierarchie which should" align:#left
			label l4 " be exported." align:#left
		)
		group "About"
		(
			label l_1 " LWS-Export v0.75/R4" align:#left
			label l_2 " April 2002" align:#left
			label l_3 " by Michael Brempel" align:#left
			label l_4 " mbrempel@gmx.de" align:#left
		)
	)
		
 	rollout r_lwsexport "LWS-Export"
 	(
		button b_export "export to LightwaveScene" width:143 height:17
 ----------------------------------------------------------------------------------------export

 		on b_export pressed do
  		(
 		----------------------hierarchisch sortierten Array holen
			if selection.count==1 then
			(
				getsubtree $			
 		------------------------------------------------
 				for i=1 to harray.count do
 				(
 					addnewkey harray[i].pos.controller 0
 					addnewkey harray[i].rotation.controller 0
 					addnewkey harray[i].scale.controller 0
 				)
 				_savepath=getsavefilename filename:"*.lws" types:"LightwaveScene(*.lws)|*.lws|All|*.*"
 				print _savepath
 				if _savepath!=undefined then
 				( 					
 					_datastream=createfile _savepath
					format ("LWSC\n3\n\n") to:_datastream
					format ("FirstFrame "+(int(animationrange.start.frame) as string)+"\n") to:_datastream
					format ("LastFrame "+(int(animationrange.end.frame) as string)+"\n") to:_datastream
					format ("FrameStep 1\n") to:_datastream
					format ("PreviewFirstFrame "+(int(animationrange.start.frame) as string)+"\n") to:_datastream
					format ("PreviewLastFrame "+(int(animationrange.end.frame) as string)+"\n") to:_datastream
					format ("PreviewFrameStep 1\n") to:_datastream
					format ("CurrentFrame "+(int(animationrange.start.frame) as string)+"\n") to:_datastream
					format ("FramesPerSecond "+(framerate as string)+"\n\n") to:_datastream
------------------------------------------------------------------
					for i=1 to harray.count do
					(
						name=harray[i].name
						--startpos_x=getlwunit(harray[i].position.x)
						--startpos_y=getlwunit(harray[i].position.y)
						--startpos_z=getlwunit(harray[i].position.z)
						--startrot_x=getlwrot(getangle ("harray["+(i as string)+"]") 1 "x")+pi/2
						--startrot_y=getlwrot(getangle ("harray["+(i as string)+"]") 1 "y")
						--startrot_z=getlwrot(getangle ("harray["+(i as string)+"]") 1 "z")
						--startscale_x=harray[i].scale.x
						--startscale_y=harray[i].scale.y
						--startscale_z=harray[i].scale.z
						poskeys=harray[i].position.controller.keys.count
						rotkeys=harray[i].rotation.controller.keys.count
						scalekeys=harray[i].scale.controller.keys.count
------------------------------------------------------------------Objekte
						if i==1 then	--root/NullObjekt
						(
							format ("AddNullObject Null\n") to:_datastream
							format ("ShowObject 6 3\n") to:_datastream
							format ("ObjectMotion\n") to:_datastream
						)
						else
						(
							if harray[i].parent==harray[1] then
							(
								aname="10000000"
							)
							else
							(
								for i2=2 to harray.count do	--assoziationsnamen zuweisen
								(
									if harray[i].parent==harray[i2] then
									(
										hexwert=bit.intAsHex (i2-2)
										if (i2-2)<16 then
											hexwert="00"+hexwert
										else if (i2-2)<256 then
											hexwert="0"+hexwert
										aname=("4"+hexwert+"0000")
										exit
									)
								)
							)
--------------------------------------------------------------------------ausgaben
							format ("BoneFalloffType 5\n") to:_datastream
							format ("AddBone\n") to:_datastream
							format ("BoneName "+name+"\n") to:_datastream
							format ("ShowBone 1 8\n") to:_datastream
							format ("BoneActive 1\n") to:_datastream
							--format ("BoneRestPosition "+(startpos_x as string)+" "+(startpos_z as string)+" "+(startpos_y as string)+"\n") to:_datastream --LW:(X,Y,Z) entspricht MAX(X,Z,Y)
							--format ("BoneRestDirection "+(startrot_z as string)+" "+(startrot_y as string)+" "+(startrot_x as string)+"\n") to:_datastream --LW:(H,P,B) entspricht MAX:(-Y,-Z,-X)
							format ("BoneRestLength "+(harray[i].length/39.37) as string+"\n") to:_datastream
							format ("BoneStrength 1\n") to:_datastream
							format ("ScaleBoneStrength 1\n") to:_datastream
							format ("BoneMotion\n") to:_datastream
						)
						format ("NumChannels 9\n") to:_datastream
--------------------------------------------------------------------------position
						format ("Channel 0\n{ Envelope\n  "+(poskeys as string)+"\n") to:_datastream
						for i2=1 to poskeys do
						(
							cpos=0
							keytime=harray[i].position.controller.keys[i2].time.frame
							if harray[i].parent==undefined then
							(
								cpos=in coordsys world(at time keytime harray[i].position.y)
							)
							else
							(							
								cpos=in coordsys parent(at time keytime harray[i].position.y)
							)
							print cpos
							cpos=-cpos/39.37
							format ("  Key "+cpos as string+" "+(keytime/framerate) as string+" 0 0 0 0 0 0 0\n") to:_datastream						
						)
						format ("  Behaviors 1 1\n}\n") to:_datastream
						format ("Channel 1\n{ Envelope\n  "+(poskeys as string)+"\n") to:_datastream
						for i2=1 to poskeys do
						(
							cpos=0
							keytime=harray[i].position.controller.keys[i2].time.frame
							if harray[i].parent==undefined then
								cpos=in coordsys world(at time keytime harray[i].position.z)
							else
							(
								cpos=in coordsys parent(at time keytime harray[i].position.z)
							)
							cpos=cpos/39.37
							format ("  Key "+cpos as string+" "+(keytime/framerate) as string+" 0 0 0 0 0 0 0\n") to:_datastream						
						)
						format ("  Behaviors 1 1\n}\n") to:_datastream
						format ("Channel 2\n{ Envelope\n  "+(poskeys as string)+"\n") to:_datastream
						for i2=1 to poskeys do
						(
							cpos=0
							keytime=harray[i].position.controller.keys[i2].time.frame
							if harray[i].parent==undefined then
								cpos=in coordsys world(at time keytime harray[i].position.x)
							else
							(
								cpos=in coordsys parent(at time keytime harray[i].position.x)
							)
							cpos=cpos/39.37
							format ("  Key "+cpos as string+" "+(keytime/framerate) as string+" 0 0 0 0 0 0 0\n") to:_datastream						
						)
						format ("  Behaviors 1 1\n}\n") to:_datastream
--------------------------------------------------------------------------rotation
						format ("Channel 3\n{ Envelope\n  "+(rotkeys as string)+"\n") to:_datastream
						for i2=1 to rotkeys do
						(
							crot=0
							keytime=harray[i].rotation.controller.keys[i2].time.frame
							if harray[i].parent==undefined then
								crot=in coordsys world(at time keytime harray[i].rotation.z_rotation)
							else
							(
								crot=in coordsys parent(at time keytime harray[i].rotation.z_rotation)
							)
							crot=pi*(-crot/180)
							format ("  Key "+crot as string+" "+(keytime/framerate) as string+" 3 0 0 0 0 0 0\n") to:_datastream						
						)
						format ("  Behaviors 1 1\n}\n") to:_datastream
						format ("Channel 4\n{ Envelope\n  "+(rotkeys as string)+"\n") to:_datastream
						for i2=1 to rotkeys do
						(
							crot=0
							keytime=harray[i].rotation.controller.keys[i2].time.frame
							if harray[i].parent==undefined then
								crot=in coordsys world(at time keytime harray[i].rotation.y_rotation)
							else
							(
								crot=in coordsys parent(at time keytime harray[i].rotation.y_rotation)
							)
							crot=pi*(crot/180)
							format ("  Key "+crot as string+" "+(keytime/framerate) as string+" 3 0 0 0 0 0 0\n") to:_datastream						
						)
						format ("  Behaviors 1 1\n}\n") to:_datastream
						format ("Channel 5\n{ Envelope\n  "+(rotkeys as string)+"\n") to:_datastream
						for i2=1 to rotkeys do
						(
							crot=0
							coordsys parent
							keytime=harray[i].rotation.controller.keys[i2].time.frame
							if harray[i].parent==undefined then
								crot=in coordsys world(at time keytime harray[i].rotation.x_rotation)
							else
							(
								crot=in coordsys parent(at time keytime harray[i].rotation.x_rotation)
							)
							crot=pi*(-crot/180)
							format ("  Key "+crot as string+" "+(keytime/framerate) as string+" 3 0 0 0 0 0 0\n") to:_datastream						
						)
						format ("  Behaviors 1 1\n}\n") to:_datastream
--------------------------------------------------------------------------scale
						format ("Channel 6\n{ Envelope\n  "+(scalekeys as string)+"\n") to:_datastream
						for i2=1 to scalekeys do
						(
							format ("  Key "+(harray[i].scale.controller.keys[i2].value.x as string)+" "+((harray[i].scale.controller.keys[i2].time.frame/framerate) as string)+" 0 0 0 0 0 0 0\n") to:_datastream						
						)
						format ("  Behaviors 1 1\n}\n") to:_datastream
						format ("Channel 7\n{ Envelope\n  "+(scalekeys as string)+"\n") to:_datastream
						for i2=1 to scalekeys do
						(
							format ("  Key "+(harray[i].scale.controller.keys[i2].value.z as string)+" "+((harray[i].scale.controller.keys[i2].time.frame/framerate) as string)+" 0 0 0 0 0 0 0\n") to:_datastream						
						)
						format ("  Behaviors 1 1\n}\n") to:_datastream
						format ("Channel 8\n{ Envelope\n  "+(scalekeys as string)+"\n") to:_datastream
						for i2=1 to scalekeys do
						(
							format ("  Key "+(harray[i].scale.controller.keys[i2].value.y as string)+" "+((harray[i].scale.controller.keys[i2].time.frame/framerate) as string)+" 0 0 0 0 0 0 0\n") to:_datastream						
						)
						format ("  Behaviors 1 1\n}\n") to:_datastream  
						if i!=1 then
						(
							format ("ParentItem "+aname+"\n\n") to:_datastream
						)
--------------------------------------------------------------------------Rest
						format ("\n") to:_datastream
--------------------------------------------------------------------------------------				
					)
					close _datastream
					harray=#()
 				)
			)
			else
			(
				messagebox "Please select (only) the root." title:"LWS-Export"
			)
 		)
--------------------------------------------------------------------------------------
 	)
	global harray=#()
	addrollout r_lwsexport r_floater
	addrollout r_info r_floater rolledUp:true
 )

 